Replace external waitfor script with a function
[autocluster.git] / autocluster
index f4a9b426b874bdf212c2f27825d22a4f19aa5b16..3c8219f150cc338d394da426d31690e207a94449 100755 (executable)
@@ -52,10 +52,14 @@ EOF
     cat <<EOF
 
   commands:
+     base [ create | boot ] ...
+
+     cluster [ build | destroy | create | update_hosts | boot | configure ] ...
+
      create base
            create a base image
 
-     create cluster CLUSTERNAME
+     create cluster [ CLUSTERNAME ]
            create a full cluster
 
      create node CLUSTERNAME IP_OFFSET
@@ -69,9 +73,6 @@ EOF
 
      bootbase
            boot the base image
-
-     testproxy
-           test your proxy setup
 EOF
     exit 1
 }
@@ -79,8 +80,45 @@ EOF
 ###############################
 
 die () {
-    fill_text 0 "ERROR: $*" >&2
-    exit 1
+    if [ "$no_sanity" = 1 ] ; then
+       fill_text 0 "WARNING: $*" >&2
+    else
+       fill_text 0 "ERROR: $*" >&2
+       exit 1
+    fi
+}
+
+announce ()
+{
+    echo "######################################################################"
+    printf "# %-66s #\n" "$*"
+    echo "######################################################################"
+    echo ""
+}
+
+waitfor ()
+{
+    local file="$1"
+    local msg="$2"
+    local timeout="$3"
+
+    local tmpfile=$(mktemp)
+
+    cat <<EOF >"$tmpfile"
+spawn tail -n 10000 -f $file
+expect -timeout $timeout -re "$msg"
+EOF
+
+    export LANG=C
+    expect "$tmpfile"
+    rm -f "$tmpfile"
+
+    if ! grep -E "$msg" "$file" > /dev/null; then
+       echo "Failed to find \"$msg\" in \"$file\""
+       return 1
+    fi
+
+    return 0
 }
 
 ###############################
@@ -149,10 +187,11 @@ register_hook ()
 run_hooks ()
 {
     local hook_var="$1"
+    shift
 
     local i
     for i in ${!hook_var} ; do
-       $i
+       $i "$@"
     done
 }
 
@@ -166,6 +205,14 @@ clear_hooks ()
 
 ##############################
 
+# These hooks are intended to customise the value of $DISK.  They have
+# access to 1 argument ("base", "system", "shared") and the variables
+# $VIRTBASE, $CLUSTER, $BASENAME (for "base"), $NAME (for "system"),
+# $SHARED_DISK_NUM (for "shared").  A hook must be deterministic and
+# should not be stateful, since they can be called multiple times for
+# the same disk.
+hack_disk_hooks=""
+
 # common node creation stuff
 create_node_COMMON ()
 {
@@ -178,21 +225,30 @@ create_node_COMMON ()
        die "Error: if BASE_FORMAT is \"qcow2\" then SYSTEM_DISK_FORMAT must also be \"qcow2\"."
     fi
 
-    IPNUM=$(($FIRSTIP + $ip_offset))
-    DISK="${VIRTBASE}/${CLUSTER}/${NAME}.${SYSTEM_DISK_FORMAT}"
-    local base_disk="${VIRTBASE}/${BASENAME}.${BASE_FORMAT}"
+    local IPNUM=$(($FIRSTIP + $ip_offset))
+    make_network_map
 
+    # Determine base image name.  We use $DISK temporarily to allow
+    # the path to be hacked.
+    local DISK="${VIRTBASE}/${BASENAME}.${BASE_FORMAT}"
     if [ "$BASE_PER_NODE_TYPE" = "yes" ] ; then
-       base_disk="${VIRTBASE}/${BASENAME}-${type}.${BASE_FORMAT}"
+       DISK="${VIRTBASE}/${BASENAME}-${type}.${BASE_FORMAT}"
     fi
+    run_hooks hack_disk_hooks "base"
+    local base_disk="$DISK"
 
-    mkdir -p $VIRTBASE/$CLUSTER tmp
+    # Determine the system disk image name.
+    DISK="${VIRTBASE}/${CLUSTER}/${NAME}.${SYSTEM_DISK_FORMAT}"
+    run_hooks hack_disk_hooks "system"
 
     local di="$DISK"
     if [ "$DISK_FOLLOW_SYMLINKS" = "yes" -a -L "$DISK" ] ; then
        di=$(readlink "$DISK")
     fi
     rm -f "$di"
+    local di_dirname="${di%/*}"
+    mkdir -p "$di_dirname"
+
     case "$SYSTEM_DISK_FORMAT" in
        qcow2)
            echo "Creating the disk..."
@@ -223,11 +279,11 @@ create_node_COMMON ()
            die "Error: unknown SYSTEM_DISK_FORMAT=\"${SYSTEM_DISK_FORMAT}\"."
     esac
 
-    set_macaddrs $CLUSTER $ip_offset
-
     # Pull the UUID for this node out of the map.
     UUID=$(awk "\$1 == $ip_offset {print \$2}" $uuid_map)
     
+    mkdir -p tmp
+
     echo "Creating $NAME.xml"
     substitute_vars $template_file tmp/$NAME.xml
     
@@ -251,6 +307,48 @@ create_node_null () {
     :
 }
 
+hack_network_map_hooks=""
+
+# Uses: CLUSTER, NAME, NETWORKS, FIRSTIP, ip_offset
+make_network_map ()
+{
+    network_map="tmp/network_map.$NAME"
+
+    if [ -n "$CLUSTER" ] ; then
+       local md5=$(echo "$CLUSTER" | md5sum)
+       local nh=$(printf "%02x" $ip_offset)
+       local mac_prefix="02:${md5:0:2}:${md5:2:2}:00:${nh}:"
+    else
+       local mac_prefix="02:42:42:00:00:"
+    fi
+
+    local n
+    local count=1
+    for n in $NETWORKS ; do
+       local ch=$(printf "%02x" $count)
+       local mac="${mac_prefix}${ch}"
+
+       set -- ${n//,/ }
+       local ip_bits="$1" ; shift
+       local dev="$1" ; shift
+       local opts="$*"
+
+       local net="${ip_bits%/*}"
+       local netname="acnet_${net//./_}"
+
+       local ip="${net%.*}.${IPNUM}"
+       local mask="255.255.255.0"
+
+       # This can be used to override the variables in the echo
+       # statement below.  The hook can use any other variables
+       # available in this function.
+       run_hooks hack_network_map_hooks
+
+       echo "${netname} ${dev} ${ip} ${mask} ${mac} ${opts}"
+       count=$(($count + 1))
+    done >"$network_map"
+}
+
 ##############################
 
 hack_nodes_functions=
@@ -346,7 +444,7 @@ common_nodelist_hacking ()
 
        local sname=""
        local hosts_line
-       local ip_addr="$IPBASE.$IPNET0.$(($FIRSTIP + $ip_offset))"
+       local ip_addr="${NETWORK_PRIVATE_PREFIX}.$(($FIRSTIP + $ip_offset))"
        
        if [ "$ctdb_node" = 1 ] ; then
            num_ctdb_nodes=$(($num_ctdb_nodes + 1))
@@ -385,7 +483,7 @@ common_nodelist_hacking ()
     ctdb_nodes_line ()
     {
        [ "$ctdb_node" = 1 ] || return 0
-       echo "$IPBASE.$IPNET0.$(($FIRSTIP + $ip_offset))"
+       echo "${NETWORK_PRIVATE_PREFIX}.$(($FIRSTIP + $ip_offset))"
        num_nodes=$(($num_nodes + 1))
     }
     nodes_file="tmp/nodes.$CLUSTER"
@@ -405,9 +503,12 @@ common_nodelist_hacking ()
 create_cluster_hooks=
 cluster_created_hooks=
 
-create_cluster ()
+cluster_create ()
 {
-    CLUSTER="$1"
+    # Use $1.  If not set then use value from configuration file.
+    CLUSTER="${1:-${CLUSTER}}"
+    announce "cluster create \"${CLUSTER}\""
+    [ -n "$CLUSTER" ] || die "\$CLUSTER not set"
 
     sanity_check_cluster_name
 
@@ -434,6 +535,101 @@ cluster_created_hosts_message ()
 
 register_hook cluster_created_hooks cluster_created_hosts_message
 
+cluster_destroy ()
+{
+    announce "cluster destroy \"${CLUSTER}\""
+    [ -n "$CLUSTER" ] || die "\$CLUSTER not set"
+
+    vircmd destroy "$CLUSTER" || true
+}
+
+cluster_update_hosts ()
+{
+    announce "cluster update_hosts \"${CLUSTER}\""
+    [ -n "$CLUSTER" ] || die "\$CLUSTER not set"
+
+    [ -n "$hosts_file" ] || hosts_file="tmp/hosts.${CLUSTER}"
+    [ -r "$hosts_file" ] || die "Missing hosts file \"${hosts_file}\""
+
+    local pat="# autocluster ${CLUSTER}\$|[[:space:]]${CLUSTER}(n|base)[[:digit:]]+"
+
+    local t="/etc/hosts.${CLUSTER}"
+    grep -E "$pat" /etc/hosts >"$t" || true
+    if diff -B "$t" "$hosts_file" >/dev/null ; then
+       rm "$t"
+       return
+    fi
+
+    local old=/etc/hosts.old.autocluster
+    cp /etc/hosts "$old"
+    local new=/etc/hosts.new
+    grep -Ev "$pat" "$old" |
+    cat -s - "$hosts_file" >"$new"
+
+    mv "$new" /etc/hosts
+
+    echo "Made these changes to /etc/hosts:"
+    diff -u "$old" /etc/hosts || true
+}
+
+cluster_boot ()
+{
+    [ -n "$CLUSTER_PATTERN" ] || CLUSTER_PATTERN="$CLUSTER"
+    announce "cluster boot \"${CLUSTER_PATTERN}\""
+    [ -n "$CLUSTER_PATTERN" ] || die "\$CLUSTER_PATTERN not set"
+
+    vircmd start "$CLUSTER_PATTERN"
+
+    local nodes=$(vircmd dominfo "$CLUSTER_PATTERN" 2>/dev/null | \
+       sed -n -e 's/Name: *//p')
+
+    # Wait for each node
+    local i
+    for i in $nodes ; do
+       waitfor "${KVMLOG}/serial.$i" "login:" 300 || {
+           vircmd destroy "$CLUSTER_PATTERN"
+           die "Failed to create cluster"
+       }
+    done
+
+    # Move past the last line of log output
+    echo ""
+}
+
+cluster_configure ()
+{
+    announce "cluster configure \"${CLUSTER}\""
+    [ -n "$CLUSTER" ] || die "\$CLUSTER not set"
+
+    local n1="${CLUSTER}n1"
+    local ssh="ssh -o StrictHostKeyChecking=no"
+
+    case "$CLUSTER_TYPE" in
+       "build")
+           $ssh "$n1" ./scripts/install_packages.sh clusterfs build
+           $ssh "$n1" ./scripts/setup_cluster.sh build
+           ;;
+
+       "ad")
+           $ssh "$n1" ./scripts/install_packages.sh ad_server
+           $ssh "$n1" ./scripts/configure_cluster.sh ad_server
+           ;;
+
+       "samba")
+           [ -n "$CLUSTER_PATTERN" ] || CLUSTER_PATTERN="$CLUSTER"
+
+           local nodes=$(vircmd dominfo "$CLUSTER_PATTERN" 2>/dev/null | \
+               sed -n -e 's/Name: *//p')
+
+           for i in $nodes ; do
+               $ssh "$i" ./scripts/install_packages.sh clusterfs nas
+           done
+
+           $ssh "$n1" ./scripts/setup_cluster.sh clusterfs nas
+           ;;
+    esac
+}
+
 create_one_node ()
 {
     CLUSTER="$1"
@@ -472,11 +668,33 @@ test_proxy() {
 
 kickstart_floppy_create_hooks=
 
-# create base image
-create_base() {
+guess_install_network ()
+{
+    # Figure out IP address to use during base install.  Default to
+    # the IP address of the 1st (private) network. If a gateway is
+    # specified then use the IP address associated with it.
+    INSTALL_IP=""
+    INSTALL_GW=""
+    local netname dev ip mask mac opts
+    while read netname dev ip mask mac opts; do
+       local o
+       for o in $opts ; do
+           case "$o" in
+               gw\=*)
+                   INSTALL_GW="${o#gw=}"
+                   INSTALL_IP="${ip}${FIRSTIP}"
+           esac
+       done
+       [ -n "$INSTALL_IP" ] || INSTALL_IP="$ip"
+    done <"$network_map"
+}
 
-    NAME="$BASENAME"
-    DISK="${VIRTBASE}/${NAME}.${BASE_FORMAT}"
+# create base image
+base_create()
+{
+    local NAME="$BASENAME"
+    local DISK="${VIRTBASE}/${NAME}.${BASE_FORMAT}"
+    run_hooks hack_disk_hooks "base"
 
     mkdir -p $KVMLOG
 
@@ -487,6 +705,9 @@ create_base() {
     if [ "$DISK_FOLLOW_SYMLINKS" = "yes" -a -L "$DISK" ] ; then
        di=$(readlink "$DISK")
     fi
+    rm -f "$di"
+    local di_dirname="${di%/*}"
+    mkdir -p "$di_dirname"
 
     echo "Creating the disk"
     qemu-img create -f $BASE_FORMAT "$di" $DISKSIZE
@@ -496,23 +717,12 @@ create_base() {
 
     setup_timezone
 
-    echo "Creating kickstart file from template"
-    substitute_vars "$KICKSTART" "tmp/ks.cfg"
-
-    if [ $INSTALLKEY = "--skip" ]; then
-       cat <<EOF
---------------------------------------------------------------------------------------
-WARNING: You have not entered an install key. Some RHEL packages will not be installed.
-
-Please enter a valid RHEL install key in your config file like this:
+    make_network_map
 
-  INSTALLKEY="1234-5678-0123-4567"
+    guess_install_network
 
-The install will continue without an install key in 5 seconds
---------------------------------------------------------------------------------------
-EOF
-       sleep 5
-    fi
+    echo "Creating kickstart file from template"
+    substitute_vars "$KICKSTART" "tmp/ks.cfg"
 
     # $ISO gets $ISO_DIR prepended if it doesn't start with a leading '/'.
     case "$ISO" in
@@ -522,7 +732,7 @@ EOF
     
     echo "Creating kickstart floppy"
     dd if=/dev/zero of=tmp/floppy.img bs=1024 count=1440
-    mkdosfs tmp/floppy.img
+    mkdosfs -n KICKSTART tmp/floppy.img
     mount -o loop -t msdos tmp/floppy.img mnt
     cp tmp/ks.cfg mnt
     mount -o loop,ro $ISO tmp/ISO
@@ -567,6 +777,7 @@ may not have matched anything at the end of the kickstart output."
 Install finished, base image $DISK created
 
 You may wish to run
+   chcon -t virt_content_t $DISK
    chattr +i $DISK
 To ensure that this image does not change
 
@@ -577,16 +788,17 @@ EOF
 
 ###############################
 # boot the base disk
-boot_base() {
-    CLUSTER="$1"
+base_boot() {
+    rm -rf tmp
+    mkdir -p tmp
 
     NAME="$BASENAME"
     DISK="${VIRTBASE}/${NAME}.${BASE_FORMAT}"
 
-    rm -rf tmp
-    mkdir -p tmp
-
     IPNUM=$FIRSTIP
+
+    make_network_map
+
     CLUSTER="base"
 
     diskimage mount $DISK
@@ -604,28 +816,6 @@ boot_base() {
 
 ######################################################################
 
-# various functions...
-
-# Set some MAC address variables based on a hash of the cluster name
-# plus the node number and each adapter number.
-set_macaddrs () {
-    local cname="$1"
-    local ip_offset="$2"
-
-    local md5=$(echo $cname | md5sum)
-    local nh=$(printf "%02x" $ip_offset)
-    local mac_prefix="02:${md5:0:2}:${md5:2:2}:00:${nh}:"
-
-    MAC1="${mac_prefix}01"
-    MAC2="${mac_prefix}02"
-    MAC3="${mac_prefix}03"
-    MAC4="${mac_prefix}04"
-    MAC5="${mac_prefix}05"
-    MAC6="${mac_prefix}06"
-}
-
-######################################################################
-
 # Updating a disk image...
 
 diskimage ()
@@ -686,10 +876,18 @@ setup_base_grub_conf ()
 {
     echo "Adjusting grub.conf"
     local o="$EXTRA_KERNEL_OPTIONS" # For readability.
-    diskimage sed "/boot/grub/grub.conf" \
-       -e "s/console=ttyS0,19200/console=ttyS0,115200/"  \
-       -e "s/ nodmraid//" -e "s/ nompath//"  \
-       -e "s/quiet/noapic divider=10${o:+ }${o}/g"
+    local grub_configs="/boot/grub/grub.conf"
+    if ! diskimage is_file "$grub_configs" ; then
+       grub_configs="/etc/default/grub /boot/grub2/grub.cfg"
+    fi
+    local c
+    for c in $grub_configs ; do
+       diskimage sed "$c" \
+           -e "s/console=ttyS0,19200/console=ttyS0,115200/"  \
+           -e "s/ console=tty1//" -e "s/ rhgb/ norhgb/"  \
+           -e "s/ nodmraid//" -e "s/ nompath//"  \
+           -e "s/quiet/noapic divider=10${o:+ }${o}/g"
+    done
 }
 
 register_hook setup_base_hooks setup_base_grub_conf
@@ -738,6 +936,40 @@ setup_network()
     echo '@@@YUM_TEMPLATE@@@' | diskimage substitute_vars - "/etc/yum.repos.d/autocluster.repo"
 
     diskimage rm_rf "/etc/udev/rules.d/70-persistent-net.rules"
+
+    echo "Setting up network interfaces: "
+    local netname dev ip mask mac opts
+    while read netname dev ip mask mac opts; do
+       echo "  $dev"
+
+       local o gw
+       gw=""
+       for o in $opts ; do
+           case "$o" in
+               gw\=*)
+                   gw="${o#gw=}"
+           esac
+       done
+
+       cat <<EOF | \
+           diskimage put - "/etc/sysconfig/network-scripts/ifcfg-${dev}"
+DEVICE=$dev
+ONBOOT=yes
+TYPE=Ethernet
+IPADDR=$ip
+NETMASK=$mask
+HWADDR=$mac
+${gw:+GATEWAY=}${gw}
+EOF
+
+       # This goes to 70-persistent-net.rules
+       cat <<EOF
+# Generated by autocluster
+SUBSYSTEM=="net", ACTION=="add", DRIVERS=="?*", ATTR{address}=="${mac}", ATTR{type}=="1", KERNEL=="eth*", NAME="${dev}"
+
+EOF
+    done <"$network_map" |
+    diskimage put - "/etc/udev/rules.d/70-persistent-net.rules"
 }
 
 register_hook setup_base_hooks setup_network
@@ -1055,31 +1287,24 @@ usage_config_options (){
     usage_smart_display load_config
 }
 
-list_releases () {
-    local releases=$(cd $installdir/releases && echo *.release)
-    releases="${releases//.release}"
-    releases="${releases// /\", \"}"
-    echo "\"$releases\""
+actions_init ()
+{
+    actions=""
 }
 
-has_public_addresses_DEFAULT ()
+actions_add ()
 {
-    false
+    actions="${actions}${actions:+ }$*"
 }
 
-make_public_addresses() {
-       local firstip="${1:-$[${FIRSTIP} + ${PUBLIC_IP_OFFSET}]}"
-       local num_addrs="${2:-${NUMNODES}}"
-
-       if [ $(( $firstip + $num_addrs - 1 )) -gt 254 ]; then
-               die "make_public_addresses: last octet > 254 - change PUBLIC_IP_OFFSET"
-       fi
+actions_run ()
+{
+    [ -n "$actions" ] || usage
 
-       local e
-       for e in $IPNET1 $IPNET2 ; do
-               echo -ne "${IPBASE}.${e}.${firstip},${num_addrs},eth${e} "
-       done
-       echo
+    local a
+    for a in $actions ; do
+       $a
+    done
 }
 
 ######################################################################
@@ -1093,7 +1318,7 @@ load_config
 ############################
 # parse command line options
 long_opts=$(getopt_config_options)
-getopt_output=$(getopt -n autocluster -o "c:e:E:xh" -l help,dump,with-release: -l "$long_opts" -- "$@")
+getopt_output=$(getopt -n autocluster -o "c:e:E:xh" -l help,dump -l "$long_opts" -- "$@")
 [ $? != 0 ] && usage
 
 use_default_config=true
@@ -1107,7 +1332,6 @@ while true ; do
        -e) shift 2 ;;
        -E) shift 2 ;;
        --) shift ; break ;;
-       --with-release) shift 2 ;; # Don't set use_default_config=false!!!
        --dump|-x) shift ;;
        -h|--help) usage ;; # Usage should be shown here for real defaults.
        --*) shift 2 ;; # Assume other long opts are valid and take an arg.
@@ -1122,12 +1346,24 @@ eval set -- "$getopt_output"
 
 while true ; do
     case "$1" in
-       # force at least ./local_file to avoid accidental file from $PATH
-       -c) . "$(dirname $2)/$(basename $2)" ; shift 2 ;;
-       -e) run_hooks post_config_hooks ; eval "$2" ; exit ;;
+       -c)
+           b=$(basename $2)
+           # force at least ./local_file to avoid accidental file
+           # from $PATH
+           . "$(dirname $2)/${b}"
+           # If $CLUSTER is unset then try to base it on the filename
+           if [ ! -n "$CLUSTER" ] ; then
+               case "$b" in
+                   *.autocluster)
+                       CLUSTER="${b%.autocluster}"
+               esac
+           fi
+           shift 2
+           ;;
+       -e) no_sanity=1 ; run_hooks post_config_hooks ; eval "$2" ; exit ;;
        -E) eval "$2" ; shift 2 ;;
        -x) set -x; shift ;;
-       --dump) run_hooks post_config_hooks ; dump_config ;;
+       --dump) no_sanity=1 ; run_hooks post_config_hooks ; dump_config ;;
        --) shift ; break ;;
        -h|--help) usage ;; # Redundant.
        --*)
@@ -1161,21 +1397,49 @@ check_command expect
 
 [ $# -lt 1 ] && usage
 
-command="$1"
+t="$1"
 shift
 
-case $command in
+case "$t" in
+    base)
+       actions_init
+       for t in "$@" ; do
+           case "$t" in
+               create|boot) actions_add "base_${t}" ;;
+               *) usage ;;
+           esac
+       done
+       actions_run
+       ;;
+
+    cluster)
+       actions_init
+       for t in "$@" ; do
+           case "$t" in
+               destroy|create|update_hosts|boot|configure)
+                   actions_add "cluster_${t}" ;;
+               build)
+                   for t in destroy create update_hosts boot configure ; do
+                       actions_add "cluster_${t}"
+                   done
+                   ;;
+               *) usage ;;
+           esac
+       done
+       actions_run
+       ;;
+
     create)
-       type=$1
+       t="$1"
        shift
-       case $type in
+       case "$t" in
            base)
                [ $# != 0 ] && usage
-               create_base
+               base_create
                ;;
            cluster)
                [ $# != 1 ] && usage
-               create_cluster "$1"
+               cluster_create "$1"
                ;;
            node)
                [ $# != 2 ] && usage
@@ -1195,10 +1459,7 @@ case $command in
        diskimage unmount
        ;;
     bootbase)
-       boot_base;
-       ;;
-    testproxy)
-       test_proxy;
+       base_boot;
        ;;
     *)
        usage;